'Funktionen zum Drucken mit API
'##############################
'Prindlg in Profan nutzen !
'##############################
'
'Definitionen
'############
'
'Memory
DEF GlobalAlloc(2)  ! "KERNEL32","GlobalAlloc"
DEF GlobalLock(1)   ! "KERNEL32","GlobalLock"
DEF GlobalUnLock(1) ! "KERNEL32","GlobalUnlock"
DEF GlobalFree(1)   ! "KERNEL32","GlobalFree"
DEF MoveMemory(3)   !"KERNEL32","RtlMoveMemory"
'
'Printdlg
DEF PrintDlg(1)             ! "COMDLG32.DLL","PrintDlgA"
DEF CommDlgExtendedError(0) ! "COMDLG32.DLL","CommDlgExtendedError"
DEF GetDeviceCaps(2)        ! "GDI32","GetDeviceCaps"
'
'Koordinaten
DEF SetMapMode(2) ! "GDI32","SetMapMode"
DEF GetMapMode(1) ! "GDI32","GetMapMode"
'
'Objekte
DEF SelectObject(2) ! "GDI32","SelectObject"
'
DEF CreateStockObject(1) ! "GDI32","GetStockObject"
'
'Zeichen-Funktionen
DEF _DrawText(5)  ! "GDI32","TextOutA"
DEF _Rectangle(5) ! "GDI32","Rectangle"
DEF _Ellipse(5)   ! "GDI32","Ellipse"
DEF _Roundrect(7) ! "GDI32","RoundRect"
DEF _LineTo(3)    ! "GDI32","LineTo"
DEF _MoveToEx(4)  ! "GDI32","MoveToEx"
'
'Hintergrund
'
DEF SetBkMode(2) ! "GDI32","SetBkMode"
DEF GetBkMode(1) ! "GDI32","TextOutA"
'
'Text_Funktionen
DEF _SetTextColor(2) ! "GDI32","SetTextColor"
DEF _DrawTextEx(6) ! "USER32","DrawTextExA"
DEF _SetRect(5) ! "USER32","SetRect"
'
'Bilder
DEF LoadImage(6)          ! "USER32","LoadImageA"
DEF BitBlt(9)             ! "GDI32","BitBlt"
DEF StretchBlt(11)        ! "GDI32","StretchBlt"
DEF CreateCompatibleDC(1) ! "GDI32","CreateCompatibleDC"
DEF DeleteDC(1)           ! "GDI32","DeleteDC"

'
'Drucken
DEF SDP(2) ! "GDI32","StartDocA"
DEF EDP(1) ! "GDI32","EndDoc"
DEF SPP(1) ! "GDI32","StartPage"
DEF EPP(1) ! "GDI32","EndPage"
'
'Strukturen
Struct PrintDlg = lStructSize&,hwndOwner&,hDevMode&,hDevNames&,hDC&,Flags&,nFromPage%,\
                  nToPage%,nMinPage%,nMaxPage%,nCopies%,hInstance&,lCustData&,\
                  lpfnPrintHook&,lpfnSetupHook&,lpPrintTemplateName&,lpSetupTemplateName&,\
                  hPrintTemplate&,hSetupTemplate&
Struct DOCINFO  = cbSize&,lpszDocName&,lpszOutput&,lpszDatatype&,fwType&
Struct RECT     = Left&,Top&,Right&,Bottom&
'
'
'Globale Variablen und Bereichsvariablen
'#######################################
Declare _Printdlg#,_DocInfo#,_Devmode#,b#
'
'Proceduren
'##########
'
Proc _ShowPrintdlg
'#######################
'Printer-Dialog anzeigen
'#######################
'Parameter :
'1 = min. Seite
'2 = max Seite
'Rckgabe ist das Printer-DC, mit dem weitegearbeitet werden kann.
'
Declare Retval&
Parameters _FromPage%,_ToPage%
Dim _Printdlg#,Printdlg
Clear _PrintDlg#
With _Printdlg#
.lStructsize& = 66
.hwndOwner&   = %hwnd
.hDevmode&    = 0
.hDevnames&   = 0
.hDc&         = 0
.Flags&       = $000040100
.nFromPage%   = _FromPage%
.nToPage%     = _ToPage%
.nMinPage%    = _FromPage%
.nMaxPage%    = _ToPage%
.nCopies%     = 0
.hInstance&  = %Hinstance
EndWith
RetVal& = 0
If Printdlg(_Printdlg#) = 1
Retval& = _Printdlg#.hDC&
Endif
Dispose _Printdlg#
Return Retval&
EndProc
'
Proc _GetPMargins
'##################################################
'Nichtdruckbare Bereiche ( Seitenrnder ) ermitteln.
'##################################################
Declare Retval$
Declare APX!,APY!,PB!,PH!,POX!,POY!,DPIX!,DPIY!,PBMM!,PHMM!,RMM!
Declare POR!,PUR!
Declare PLR!,PRR!
Parameters _PrinterDC&
'Rckgabe ist ein String, der die Seitenrnder
'in 1/100 mm enthlt
'links, rechts, oben, unten
'
APX!  = GetDeviceCaps(_PrinterDC&,8)'Ausgabebreite in Pixel
APY!  = GetDeviceCaps(_PrinterDC&,10)'AusgabeHoehe in Pixel
PB!   = GetDeviceCaps(_PrinterDC&,110)'Physikalische Breite
PH!   = GetDeviceCaps(_PrinterDC&,111)'Physikalische Hoehe
POX!  = GetDeviceCaps(_PrinterDC&,112)'Offset X
POY!  = GetDeviceCaps(_PrinterDC&,113)'Offset Y
DPIX! = GetDeviceCaps(_PrinterDC&,88)'DPI X
DPIY! = GetDeviceCaps(_PrinterDC&,90)'DPI Y
PBMM! = GetDeviceCaps(_PrinterDC&,4)'Ausgabebreite in mm
PHMM! = GetDeviceCaps(_PrinterDC&,6)'Ausgabehoehe in mm
'Rnder errechnen
Decimals 0
PLR!=ROUND(MUL(DIV(PBMM!,APX!),POX!),1)
PRR!=ROUND(MUL(DIV(PBMM!,APX!),SUB(SUB(PB!,APX!),POX!)),1)
POR!=ROUND(MUL(DIV(PHMM!,APY!),POY!),1)
PUR!=ROUND(MUL(DIV(PHMM!,APY!),SUB(SUB(PH!,APY!),POY!)),1)
Retval$ = Str$(PLR!*100)+","+Str$(PRR!*100)+","+Str$(POR!*100)+","+Str$(PUR!*100)+","+Str$(PBMM!*100)+","+Str$(PHMM!*100)
Return Retval$
EndProc
'
Proc GetBMPDimensions
Parameters BMPName$
Declare Retval$,ow&,oh&
Dim b#,8
Assign #1,BMPname$
OpenRW #1
Seek #1,18
@BlockRead(#1,B#,0,8)
CloseRW #1
Let ow& = Long(b#,0)
Let oh& = Long(b#,4)
RetVal$ = str$(ow&)+","+Str$(oh&)
Dispose b#
Return Retval$
EndProc

Proc DrawBitmap
Parameters PrinterDC&,Picname$,x%,y%,w%,h%
Declare Image&,MyDC&,PicObject&,orgw&,orgh&
Image&     = LoadImage(%Hinstance,addr(Picname$),0,0,0,$3050)
MyDC&      = CreateCompatibleDC(PrinterDC&)
PicObject& = SelectObject(MyDC&,Image&)
GetBMPDimensions Picname$
Orgw& = Val(Substr$(@$(0),1,","))
Orgh& = Val(Substr$(@$(0),2,","))
StretchBlt(PrinterDC&,x%,y%,w%,h%,MyDC&,0,0,orgw&,orgh&,$0CC0020)
DeleteObject PicObject&
DeleteDc(MyDC&)
EndProc

